import java.math.*;

public class Treppe {

   public static void main(String[] args) {
      if (args.length < 1 || args.length > 2) {
         System.err.println("Usage: java Treppe <number> [efficient]");
         System.exit(-1);
      }
      int n = Integer.parseInt(args[0]);
      boolean efficient = (args.length == 2);
      BigInteger res;
      long start = System.currentTimeMillis();
      res = efficient ? ts_fast(n) : ts(n);
      long end = System.currentTimeMillis();
      System.out.println("Time: " + (end - start));
      System.out.println("Result: " + res);
   }
   
   static BigInteger ts(int n) {
      if (n <= 1) {
         return BigInteger.ONE;
      } else {
         return ts(n-1).add(ts(n-2));
      }
   }
   
   static BigInteger ts_fast(int n) {
      BigInteger tmp, ts_i, ts_i_min_1;
      int i = 1;
      ts_i = BigInteger.ONE;
      ts_i_min_1 = BigInteger.ONE;
      while (n > i) {
         i++;
         tmp = ts_i;
         ts_i = ts_i.add(ts_i_min_1);
         ts_i_min_1 = tmp;
      }
      return ts_i;
   }
   
}
